/*
 *      lark-document-loader.h
 *
 *      Copyright 2016-2018 Alex <alex@linuxonly.ru>
 *
 *      This program is free software: you can redistribute it and/or modify
 *      it under the terms of the GNU General Public License as published by
 *      the Free Software Foundation; either version 3 of the License, or
 *      (at your option) any later version.
 *
 *      This program is distributed in the hope that it will be useful,
 *      but WITHOUT ANY WARRANTY; without even the implied warranty of
 *      MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *      GNU General Public License for more details.
 *
 *      You should have received a copy of the GNU General Public License
 *      along with this program. If not, see <http://www.gnu.org/licenses/>.
 */

#ifndef LARK_DOCUMENT_LOADER_H
#define LARK_DOCUMENT_LOADER_H

#include <gtk/gtk.h>
#include <glib/gi18n.h>

G_BEGIN_DECLS

enum _LarkDocumentLoaderFormat {
	LARK_DOCUMENT_LOADER_FORMAT_UNKNOWN = 0,
	LARK_DOCUMENT_LOADER_FORMAT_TXT,
	LARK_DOCUMENT_LOADER_FORMAT_PDF,
	LARK_DOCUMENT_LOADER_FORMAT_EPUB,
	LARK_DOCUMENT_LOADER_FORMAT_FB2,
	LARK_DOCUMENT_LOADER_FORMAT_FB2_ZIP
};

#define LARK_TYPE_DOCUMENT_LOADER (lark_document_loader_get_type ())

G_DECLARE_FINAL_TYPE (LarkDocumentLoader, lark_document_loader, LARK, DOCUMENT_LOADER, GObject)

LarkDocumentLoader *lark_document_loader_new(void);

gboolean lark_document_loader_open(LarkDocumentLoader *self, gchar *path, GError **error);

gchar *lark_document_loader_get_filename(LarkDocumentLoader *self);
gchar *lark_document_loader_get_title(LarkDocumentLoader *self);
gchar *lark_document_loader_get_author(LarkDocumentLoader *self);
gchar *lark_document_loader_get_comment(LarkDocumentLoader *self);

G_END_DECLS

#endif /* LARK_DOCUMENT_LOADER */
